// msis.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int iday;
	double sec, alt, glat, glong, stl, f107a, f107; 
	double ap[7], d[8], t[2];

	static double h, an[6], wmol, rhod, rjud, dafr, gsti;
	static double sa[3], su[2], sf[3], te[2];
	static int i, j;
	static int rl[5] = {-60, -30, 0, 30, 60};

	FILE *nfil;

	iday  = 172;	// day of the year
	sec   = 29000.;	// utc in seconds
	alt   = 400.;	// altitude in km
	glat  = 60.;	// latitude geodetic in degrees
	glong = -70.;	// longitude in degrees
	stl	  = 16.;	// local solar time in hours
	f107a = 150.;	// mean solar flux over 90 days
	f107  = 150.;	// solar flux from previous day
	ap[0] = 4;		// dayly Ap
	ap[1] = 4;		// 3 hr ap index for current time  
	ap[2] = 4;		// 3 hr ap index for 3 hrs before current time
	ap[3] = 4;		// 3 hr ap index for 6 hrs before current time
	ap[4] = 4;		// 3 hr ap index for 9 hrs before current time
	ap[5] = 4;		// average of eight 3 hr ap indicies from 12 to 33 hrs prior to current time
	ap[6] = 4;		// average of eight 3 hr ap indicies from 36 to 59 hrs prior to current time

	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	iday  = 81;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	iday  = 172;
	sec   = 75000.;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	sec   = 29000.;
	alt   = 100.;
	ap[6] = 40;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	alt   = 400.;
	glat  = 0.;
	ap[5] = 40;
	ap[6] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	glat  = 60.;
	glong = 0.;
	ap[4] = 40;
	ap[5] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	glong = -70.;
	stl	  = 4.;
	ap[3] = 40;
	ap[4] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	stl	  = 16.;
	f107a = 70.;
	ap[2] = 40;
	ap[3] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	f107a = 150.;
	f107  = 180.;
	ap[1] = 40;
	ap[2] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	f107  = 150.;
	ap[0] = 40;
	ap[1] = 0;
	gts5(iday, sec, alt, glat, glong, stl, f107a, f107, ap, d, t);
	printf (" %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %9.3g %10.4g %10.4g \n",
		d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], t[0], t[1]);

	// ************** dynamic model ****************

	nfil = fopen("msstatc.dat", "w");
	sf[0] = 100.;
	sf[1] = 100.;
	sf[2] = kp_to_ap(5.);
	sa[0] = 0.;
	sa[1] = 0.;
	su[0] = 0.;
	su[1] = 0.;
	rjud  = 22476.;
	dafr  = 0.;
	gsti  = 293.49/180.*3.141592;
	printf("\n\n ******************************** Dynamic Model ");
	printf("*******************************\n F10.7 = %6.2f, Fbar = %6.2f, Ap = %6.2f, ",
		sf[0], sf[1], sf[2]);
	printf(" Right ascension (deg) = %6.2f, \n", sa[0]);
	printf(" Greenwich Sidereal Time (rad) = %8.3f \n",
		gsti);
	printf(" Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	printf ("  Alt MMolMs LogDsty ExTemp LcTemp NMolHe NMolO2 NMolN2 NMolAr NMmolO  NMolH\n");

	fprintf(nfil, " ******************************************************************************\n");
	fprintf(nfil, "                                 MSIS-86 Model\n");
	fprintf(nfil,"\n\n ******************************** Dynamic Model ");
	fprintf(nfil,"*******************************\n F10.7 = %6.2f, Fbar = %6.2f,",
		sf[0], sf[1]);
	fprintf(nfil," Ap = %6.2f, Right ascension (deg) = %6.2f, \n", sf[2], sa[0]);
	fprintf(nfil," Greenwich Sidereal Time (rad) = %8.3f, \n",
		gsti);
	fprintf(nfil," Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	fprintf(nfil,"                                  Latitude (deg) \n");
	fprintf(nfil,"  Alt MMolMs LogDsty ExTemp LcTemp NMolHe NMolO2 NMolN2 NMolAr NMmolO  NMolH\n");

	for (h = 90; h <= 2000; h+=10)
	{
		sa[2] = h*1000.;
		msdamo(sa, su, sf, rjud, dafr, gsti, te, an, &wmol, &rhod);
		printf (" %4d %6.2f%8.3f%7.2f%7.2f%7.3f%7.3f%7.3f%7.3f%7.3f%7.3f\n",
			int(h), wmol, log10(rhod), te[0], te[1],
			an[0], an[1], an[2], an[3], an[4], an[5]);
		fprintf(nfil," %4d %6.2f%8.3f%7.2f%7.2f%7.3f%7.3f%7.3f%7.3f%7.3f%7.3f\n",
			int(h), wmol, log10(rhod), te[0], te[1],
			an[0], an[1], an[2], an[3], an[4], an[5]);
	}

	fclose(nfil);

	nfil = fopen("msdynmc.dat", "w");
	sf[0] = 100.;
	sf[1] = 100.;
	sf[2] = kp_to_ap(5.);
	sa[0] = 0.;
	sa[1] = 0.;
	sa[2] = 600000.;
	su[0] = 0.;
	su[1] = 0.;
	rjud  = 22476.;
	dafr  = 0.;
	gsti  = 293.49/180.*3.141592;
	printf("\n\n ******************************** Dynamic Model ");
	printf("*******************************\n F10.7 = %6.2f, Fbar = %6.2f,",
		sf[0], sf[1]);
	printf(" Kp = %3.1f, Right ascension (deg) = %6.2f, \n", sf[2], sa[0]);
	printf(" Greenwich Sederal Time (rad) = %8.3f, Altitude (km) = %6.2f, \n",
		gsti, sa[2]/1000.);
	printf(" Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	printf("                                  Latitude (deg) \n");
	printf("SunRA    %4d           %4d           %4d           %4d           %4d \n",
		int(rl[0]), int(rl[1]), int(rl[2]), int(rl[3]), int(rl[4]), int(rl[5]));
	printf(" deg mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");
	fprintf(nfil, " ******************************************************************************\n");
	fprintf(nfil, "                                 MSIS-86 Model\n");
	fprintf(nfil,"\n\n ******************************** Dynamic Model ");
	fprintf(nfil,"*******************************\n F10.7 = %6.2f, Fbar = %6.2f,",
		sf[0], sf[1]);
	fprintf(nfil," Kp = %3.1f, Right ascension (deg) = %6.2f, \n", sf[2], sa[0]);
	fprintf(nfil," Greenwich Sederal Time (rad) = %8.3f, Altitude (km) = %6.2f, \n",
		gsti, sa[2]/1000.);
	fprintf(nfil," Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	fprintf(nfil,"                                  Latitude (deg) \n");
	fprintf(nfil,"SunRA    %4d           %4d           %4d           %4d           %4d \n",
		int(rl[0]), int(rl[1]), int(rl[2]), int(rl[3]), int(rl[4]), int(rl[5])) ;
	fprintf(nfil," deg mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");
	for (h = -180; h <= 180; h+=5)
	{
		sa[0] = h*3.141592/180.;
		printf("%4d", int(h)); 
		fprintf(nfil, "%4d", int(h)); 
		for (i = 0; i < 5; i++)
		{
			sa[1] = rl[i]*3.141592/180.;
			msdamo(sa, su, sf, rjud, dafr, gsti, te, an, &wmol, &rhod);
			printf(" %6.2f%8.3f", wmol, log10(rhod));
			fprintf(nfil, " %6.2f%8.3f", wmol, log10(rhod));
		}
		printf("\n");
		fprintf(nfil, "\n");
	}
	fclose(nfil);



	return 0;
}

