// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>
#include <math.h>
#include <stdlib.h>
#include "atmodels.h"

// TODO: reference additional headers your program requires here

void gts5(int iday, double sec, double alt, double glat, double glong,
		  double stl, double f107a, double f107, double ap[],
		  double d[], double t[]);
double denss (double alt, double dlb, double tinf, double tlb, double xm,
			  double alpha, double zlb, double s2, double t0,
			  double za, double z0, double tr12);
double zeta (double zz, double zl);
double globe5 (double day, double sec, double lat, double along, double tloc, 
			 double f107a, double f107, double ap[], double p[]);
double __g0 (double a, double p25, double p26);
double __sumex (double ex);
double __sg0 (double ex, double ap[], double p[]);
void tselec(double sv[]);
void tretrv(double svv[]);
double glob5l(double p[]);
double dnet (double dd, double dm, double zhm, double xmm, double xm);
double ccor (double alt, double r, double h1, double zh);

void msdamo (double sa[], double su[], double sf[], double rjud, double dafr, double gsti,
			double te[], double ad[], double *wmol, double *rhod);
double gst (int mjd, double tsec);
int djm (int day, int month, int year);
void djm_inv (int mjd, double dmy[]);
double ap_to_kp (double ap);
double kp_to_ap (double kp);